#include <sourcemod>
#include <sdkhooks>
#include <sdktools>
#include <multicolors>
#include <autoexecconfig>
#include <adminmenu>

#pragma semicolon 1

#define DEBUG

#pragma newdecls required

public Plugin myinfo = 
{
	name = "Grenades Rounds", 
	author = "LanteJoula", 
	description = "Grenades Rounds", 
	version = "1.1", 
	url = "https://steamcommunity.com/id/lantejoula/"
};

//ConVar

char g_ChatPrefix[256];
ConVar gConVar_Chat_Prefix;

ConVar gConVar_Molotov_RoundEnd_Message;
ConVar gConVar_HE_RoundEnd_Message;
ConVar gConVar_Smoke_RoundEnd_Message;
ConVar gConVar_FlashBang_RoundEnd_Message;
ConVar gConVar_Decoy_RoundEnd_Message;

ConVar gConVar_Molotov_RoundStart_Message;
ConVar gConVar_HE_RoundStart_Message;
ConVar gConVar_Smoke_RoundStart_Message;
ConVar gConVar_FlashBang_RoundStart_Message;
ConVar gConVar_Decoy_RoundStart_Message;

ConVar gConVar_Molotov_RoundForceStop_Message;
ConVar gConVar_HE_RoundForceStop_Message;
ConVar gConVar_Smoke_RoundForceStop_Message;
ConVar gConVar_FlashBang_RoundForceStop_Message;
ConVar gConVar_Decoy_RoundForceStop_Message;

ConVar gConVar_Start_Vote_Message;
ConVar gConVar_Votes_Resultes_Message;

ConVar gConVar_ForceStopRound_ResetCoolDown;
ConVar gConVar_CoolDown;

//BOOL

bool MolotovRound = false;
bool HERound = false;
bool SmokeRound = false;
bool FlashBangRound = false;
bool DecoyRound = false;

bool MolotovRound1 = true;
bool HERound1 = true;
bool SmokeRound1 = true;
bool FlashBangRound1 = true;
bool DecoyRound1 = true;

//VOTES GRENADES ROUNDS

int Mode;
int Cooldown;

int yes;
int no;

bool ModeVoted = false;

bool ShowMenuGrenadesRoundsVotes = false;

//ADMIN MENU

Handle hAdminMenu;

//KNIFE OFF

bool KnifeDamage = true;

public void OnPluginStart()
{
	LoadTranslations("grenadesrounds.phrases");
	
	//COMMANDS
	
	RegAdminCmd("sm_agrenadesrounds", AdminGrenadesRoundsMenu, ADMFLAG_GENERIC);
	RegAdminCmd("sm_agrenadesround", AdminGrenadesRoundsMenu, ADMFLAG_GENERIC);
	RegAdminCmd("sm_agr", AdminGrenadesRoundsMenu, ADMFLAG_GENERIC);
	
	RegConsoleCmd("sm_grenadesrounds", GrenadesRoundsMenu);
	RegConsoleCmd("sm_grenadesround", GrenadesRoundsMenu);
	RegConsoleCmd("sm_gr", GrenadesRoundsMenu);
	
	//EVENTS
	
	HookEvent("round_end", OnRoundEnd);
	HookEvent("round_start", OnRoundStart1);
	
	//AutoExecConfig
	
	AutoExecConfig_SetFile("plugin.grenadesrounds");
	
	gConVar_Chat_Prefix = AutoExecConfig_CreateConVar("sm_grenadesrounds_chat_prefix", "{green}[TAG]{default}", "Chat Prefix");
	
	gConVar_Molotov_RoundEnd_Message = AutoExecConfig_CreateConVar("sm_grenadesrounds_molotov_roundend_message", "1", "Enable/Disable Message when Molotov Round End (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_HE_RoundEnd_Message = AutoExecConfig_CreateConVar("sm_grenadesrounds_he_roundend_message", "1", "Enable/Disable Message when HE Round End (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_Smoke_RoundEnd_Message = AutoExecConfig_CreateConVar("sm_grenadesrounds_smoke_roundend_message", "1", "Enable/Disable Message when Smoke Round End (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_FlashBang_RoundEnd_Message = AutoExecConfig_CreateConVar("sm_grenadesrounds_flash_roundend_message", "1", "Enable/Disable Message when Flash Round End (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_Decoy_RoundEnd_Message = AutoExecConfig_CreateConVar("sm_grenadesrounds_decoy_roundend_message", "1", "Enable/Disable Message when Decoy Round End (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	gConVar_Molotov_RoundStart_Message = AutoExecConfig_CreateConVar("sm_grenadesrounds_molotov_roundstart_message", "1", "Enable/Disable Message when Molotov Round Start (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_HE_RoundStart_Message = AutoExecConfig_CreateConVar("sm_grenadesrounds_he_roundstart_message", "1", "Enable/Disable Message when HE Round Start (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_Smoke_RoundStart_Message = AutoExecConfig_CreateConVar("sm_grenadesrounds_smoke_roundstart_message", "1", "Enable/Disable Message when Smoke Round Start (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_FlashBang_RoundStart_Message = AutoExecConfig_CreateConVar("sm_grenadesrounds_flash_roundstart_message", "1", "Enable/Disable Message when Flash Round Start (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_Decoy_RoundStart_Message = AutoExecConfig_CreateConVar("sm_grenadesrounds_decoy_roundstart_message", "1", "Enable/Disable Message when Decoy Round Start (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	gConVar_Molotov_RoundForceStop_Message = AutoExecConfig_CreateConVar("sm_grenadesrounds_molotov_roundforcestop_message", "1", "Enable/Disable Message when Force Stop Molotov Round (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_HE_RoundForceStop_Message = AutoExecConfig_CreateConVar("sm_grenadesrounds_he_roundforcestop_message", "1", "Enable/Disable Message when Force Stop HE Round (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_Smoke_RoundForceStop_Message = AutoExecConfig_CreateConVar("sm_grenadesrounds_smoke_roundforcestop_message", "1", "Enable/Disable Message when Force Stop Smoke Round (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_FlashBang_RoundForceStop_Message = AutoExecConfig_CreateConVar("sm_grenadesrounds_flash_roundforcestop_message", "1", "Enable/Disable Message when Force Stop Flash Round (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_Decoy_RoundForceStop_Message = AutoExecConfig_CreateConVar("sm_grenadesrounds_decoy_roundforcestop_message", "1", "Enable/Disable Message when Force Stop Decoy Round (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	gConVar_Start_Vote_Message = AutoExecConfig_CreateConVar("sm_start_vote_message", "1", "Enable/Disable the Message on Chat when Player Start Vote (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_Votes_Resultes_Message = AutoExecConfig_CreateConVar("sm_votes_results_message", "1", "Enable/Disable the Message on Chat with Votes Resultes (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	gConVar_ForceStopRound_ResetCoolDown = AutoExecConfig_CreateConVar("sm_forcestopround_resetcooldown", "1", "Reset Cooldown for Player Start Vote if any Admin Force Stop Round (1 - Yes | 0 - No)", 0, true, 0.0, true, 1.0);
	gConVar_CoolDown = AutoExecConfig_CreateConVar("sm_cooldown", "5", "Cooldown Between Votes (Default - 5)", 0, true, 0.0, true, 100.0);
	
	AutoExecConfig_ExecuteFile();
	AutoExecConfig_CleanFile();
	
	gConVar_Chat_Prefix.AddChangeHook(OnPrefixChange);
	
	//KNIFE OFF
	
	for (int client = 1; client <= MaxClients; client++)
	{
		if (IsClientInGame(client))
		{
			SDKHook(client, SDKHook_OnTakeDamage, TakeDamageHook);
		}
	}
	
	RegAdminCmd("sm_knifeoffgrenadesrounds", KnifeOff, ADMFLAG_GENERIC);
	RegAdminCmd("sm_knifeongrenadesrounds", KnifeOn, ADMFLAG_GENERIC);
	
	KnifeDamage = true;
	
	//ADVADMIN
	
	RegAdminCmd("sm_givegrenadesroundshp", CMD_Give, ADMFLAG_GENERIC, "Give something for the targets");
	RegAdminCmd("sm_disarmgrenadesroundshp", CMD_Disarm, ADMFLAG_GENERIC, "Disarming the targets");
	RegAdminCmd("sm_hpgrenadesroundshp", CMD_Health, ADMFLAG_GENERIC, "Set the health for the targets");
}

//Prefix
//Prefix
//Prefix

public void SavePrefix()
{
	GetConVarString(gConVar_Chat_Prefix, g_ChatPrefix, sizeof(g_ChatPrefix));
}

public void OnConfigsExecuted()
{
	SavePrefix();
}

public void OnPrefixChange(ConVar cvar, char[] oldvalue, char[] newvalue)
{
	SavePrefix();
}

//ADMIN MENU
//ADMIN MENU
//ADMIN MENU

public void OnAllPluginsLoaded()
{
	Handle topmenu;
	if (LibraryExists("adminmenu") && ((topmenu = GetAdminTopMenu()) != null))
		OnAdminMenuReady(topmenu);
}

public void OnAdminMenuReady(Handle topmenu)
{
	if (topmenu == hAdminMenu)
		return;
	
	hAdminMenu = topmenu;
	CreateTimer(1.0, Timer_AttachAdminMenu);
}

public Action Timer_AttachAdminMenu(Handle timer)
{
	TopMenuObject menu_category = AddToTopMenu(hAdminMenu, "admingrenadesrounds", TopMenuObject_Category, Handle_Category, INVALID_TOPMENUOBJECT, "admingrenadesrounds", ADMFLAG_GENERIC);
	if (menu_category == INVALID_TOPMENUOBJECT)
		return;
	
	AddToTopMenu(hAdminMenu, "sm_agrenadesrounds", TopMenuObject_Item, AdminMenu_StaffMode, menu_category, "sm_agrenadesrounds", ADMFLAG_GENERIC);
}

public void Handle_Category(TopMenu topmenu, TopMenuAction action, TopMenuObject topobj_id, int param, char[] buffer, int maxlength)
{
	if (action == TopMenuAction_DisplayTitle)
		Format(buffer, maxlength, "%T\n ", "Grenades Rounds Title in Admin", param);
	else if (action == TopMenuAction_DisplayOption)
		Format(buffer, maxlength, "%T\n ", "Grenades Rounds Title in Admin", param);
}

public void AdminMenu_StaffMode(TopMenu topmenu, TopMenuAction action, TopMenuObject topobj_id, int param, char[] buffer, int maxlength)
{
	if (action == TopMenuAction_DisplayOption)
		Format(buffer, maxlength, "%t", "Grenades Rounds Buttom in Admin", param);
	else if (action == TopMenuAction_SelectOption)
		ShowMenu(param);
}

//PLUGIN
//PLUGIN
//PLUGIN

public Action AdminGrenadesRoundsMenu(int client, int args)
{
	ShowMenu(client);
}

void ShowMenu(int client)
{
	char MolotovStart[128];
	char MolotovEnd[128];
	
	char HEStart[128];
	char HEEnd[128];
	
	char SmokeStart[128];
	char SmokeEnd[128];
	
	char FlashStart[128];
	char FlashEnd[128];
	
	char DecoyStart[128];
	char DecoyEnd[128];
	
	Menu menu = new Menu(Menu_Handler);
	menu.SetTitle("%t\n ", "Admin Grenades Rounds Title");
	
	//Molotov
	if (HERound1 && SmokeRound1 && FlashBangRound1 && DecoyRound1 && !ShowMenuGrenadesRoundsVotes)
	{
		if (!MolotovRound)
		{
			Format(MolotovStart, sizeof(MolotovStart), "%t", "AdminMolotovRoundStartMenu");
			menu.AddItem("1", MolotovStart);
		}
		else
		{
			Format(MolotovEnd, sizeof(MolotovEnd), "%t", "AdminMolotovRoundStopMenu");
			menu.AddItem("2", MolotovEnd);
		}
	}
	else
	{
		Format(MolotovStart, sizeof(MolotovStart), "%t", "AdminMolotovRoundStartMenu");
		menu.AddItem("1", MolotovStart, ITEMDRAW_DISABLED);
	}
	
	//HE
	if (MolotovRound1 && SmokeRound1 && FlashBangRound1 && DecoyRound1 && !ShowMenuGrenadesRoundsVotes)
	{
		if (!HERound)
		{
			Format(HEStart, sizeof(HEStart), "%t", "AdminHERoundStartMenu");
			menu.AddItem("3", HEStart);
		}
		else
		{
			Format(HEEnd, sizeof(HEEnd), "%t", "AdminHERoundStopMenu");
			menu.AddItem("4", HEEnd);
		}
	}
	else
	{
		Format(HEStart, sizeof(HEStart), "%t", "AdminHERoundStartMenu");
		menu.AddItem("3", HEStart, ITEMDRAW_DISABLED);
	}
	
	//Smoke
	if (MolotovRound1 && HERound1 && FlashBangRound1 && DecoyRound1 && !ShowMenuGrenadesRoundsVotes)
	{
		if (!SmokeRound)
		{
			Format(SmokeStart, sizeof(SmokeStart), "%t", "AdminSmokeRoundStartMenu");
			menu.AddItem("5", SmokeStart);
		}
		else
		{
			Format(SmokeEnd, sizeof(SmokeEnd), "%t", "AdminSmokeRoundStopMenu");
			menu.AddItem("6", SmokeEnd);
		}
	}
	else
	{
		Format(SmokeStart, sizeof(SmokeStart), "%t", "AdminSmokeRoundStartMenu");
		menu.AddItem("5", SmokeStart, ITEMDRAW_DISABLED);
	}
	
	//Flash
	if (MolotovRound1 && HERound1 && SmokeRound1 && DecoyRound1 && !ShowMenuGrenadesRoundsVotes)
	{
		if (!FlashBangRound)
		{
			Format(FlashStart, sizeof(FlashStart), "%t", "AdminFlashRoundStartMenu");
			menu.AddItem("7", FlashStart);
		}
		else
		{
			Format(FlashEnd, sizeof(FlashEnd), "%t", "AdminFlashRoundStopMenu");
			menu.AddItem("8", FlashEnd);
		}
	}
	else
	{
		Format(FlashStart, sizeof(FlashStart), "%t", "AdminFlashRoundStartMenu");
		menu.AddItem("7", FlashStart, ITEMDRAW_DISABLED);
	}
	
	//Decoy
	if (MolotovRound1 && HERound1 && SmokeRound1 && FlashBangRound1 && !ShowMenuGrenadesRoundsVotes)
	{
		if (!DecoyRound)
		{
			Format(DecoyStart, sizeof(DecoyStart), "%t", "AdminDecoyRoundStartMenu");
			menu.AddItem("9", DecoyStart);
		}
		else
		{
			Format(DecoyEnd, sizeof(DecoyEnd), "%t", "AdminDecoyRoundStopMenu");
			menu.AddItem("10", DecoyEnd);
		}
	}
	else
	{
		Format(DecoyStart, sizeof(DecoyStart), "%t", "AdminDecoyRoundStartMenu");
		menu.AddItem("9", DecoyStart, ITEMDRAW_DISABLED);
	}
	
	menu.ExitButton = true;
	menu.Display(client, MENU_TIME_FOREVER);
}

public int Menu_Handler(Menu menu, MenuAction action, int client, int args)
{
	if (action == MenuAction_Select)
	{
		char selectedItem[200];
		menu.GetItem(args, selectedItem, sizeof(selectedItem));
		
		//Molotov
		if (StrEqual(selectedItem, "1"))
		{
			if (GetUserFlagBits(client))
			{
				MolotovRound = true;
				MolotovRound1 = false;
				
				char name[128];
				GetClientName(client, name, sizeof(name));
				
				if (gConVar_Molotov_RoundStart_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "AdminMolotovRoundStart", name);
				
				ServerCommand("sm_hpgrenadesroundshp @all 150");
				ServerCommand("sm_disarmgrenadesroundshp @all");
				ServerCommand("sm_givegrenadesroundshp @all molotov");
				ServerCommand("sm_givegrenadesroundshp @all knife");
				
				ServerCommand("sm_knifeoffgrenadesrounds");
				
				ServerCommand("sv_infinite_ammo 1");
			}
		}
		if (StrEqual(selectedItem, "2"))
		{
			if (GetUserFlagBits(client))
			{
				MolotovRound = false;
				MolotovRound1 = true;
				
				char name[128];
				GetClientName(client, name, sizeof(name));
				
				if (gConVar_Molotov_RoundForceStop_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "AdminMolotovRoundStop", name);
				
				ServerCommand("sm_hpgrenadesroundshp @all 100");
				ServerCommand("sm_disarmgrenadesroundshp @all");
				ServerCommand("sm_givegrenadesroundshp @all knife");
				
				ServerCommand("sm_knifeongrenadesrounds");
				
				ServerCommand("sv_infinite_ammo 0");
				
				if (gConVar_ForceStopRound_ResetCoolDown.BoolValue)
					Cooldown = 0;
			}
		}
		
		//HE
		if (StrEqual(selectedItem, "3"))
		{
			if (GetUserFlagBits(client))
			{
				HERound = true;
				HERound1 = false;
				
				char name[128];
				GetClientName(client, name, sizeof(name));
				
				if (gConVar_HE_RoundStart_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "AdminHERoundStart", name);
				
				ServerCommand("sm_hpgrenadesroundshp @all 50");
				ServerCommand("sm_disarmgrenadesroundshp @all");
				ServerCommand("sm_givegrenadesroundshp @all hegrenade");
				ServerCommand("sm_givegrenadesroundshp @all knife");
				
				ServerCommand("sm_knifeoffgrenadesrounds");
				
				ServerCommand("sv_infinite_ammo 1");
			}
		}
		if (StrEqual(selectedItem, "4"))
		{
			if (GetUserFlagBits(client))
			{
				HERound = false;
				HERound1 = true;
				
				char name[128];
				GetClientName(client, name, sizeof(name));
				
				if (gConVar_HE_RoundForceStop_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "AdminHERoundStop", name);
				
				ServerCommand("sm_hpgrenadesroundshp @all 100");
				ServerCommand("sm_disarmgrenadesroundshp @all");
				ServerCommand("sm_givegrenadesroundshp @all knife");
				
				ServerCommand("sm_knifeongrenadesrounds");
				
				ServerCommand("sv_infinite_ammo 0");
				
				if (gConVar_ForceStopRound_ResetCoolDown.BoolValue)
					Cooldown = 0;
			}
		}
		
		//Smoke
		if (StrEqual(selectedItem, "5"))
		{
			if (GetUserFlagBits(client))
			{
				SmokeRound = true;
				SmokeRound1 = false;
				
				char name[128];
				GetClientName(client, name, sizeof(name));
				
				if (gConVar_Smoke_RoundStart_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "AdminSmokeRoundStart", name);
				
				ServerCommand("sm_hpgrenadesroundshp @all 1");
				ServerCommand("sm_disarmgrenadesroundshp @all");
				ServerCommand("sm_givegrenadesroundshp @all smokegrenade");
				ServerCommand("sm_givegrenadesroundshp @all knife");
				
				ServerCommand("sm_knifeoffgrenadesrounds");
				
				ServerCommand("sv_infinite_ammo 1");
			}
		}
		if (StrEqual(selectedItem, "6"))
		{
			if (GetUserFlagBits(client))
			{
				SmokeRound = false;
				SmokeRound1 = true;
				
				char name[128];
				GetClientName(client, name, sizeof(name));
				
				if (gConVar_Smoke_RoundForceStop_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "AdminSmokeRoundStop", name);
				
				ServerCommand("sm_hpgrenadesroundshp @all 100");
				ServerCommand("sm_disarmgrenadesroundshp @all");
				ServerCommand("sm_givegrenadesroundshp @all knife");
				
				ServerCommand("sm_knifeongrenadesrounds");
				
				ServerCommand("sv_infinite_ammo 0");
				
				if (gConVar_ForceStopRound_ResetCoolDown.BoolValue)
					Cooldown = 0;
			}
		}
		
		//Flash
		if (StrEqual(selectedItem, "7"))
		{
			if (GetUserFlagBits(client))
			{
				FlashBangRound = true;
				FlashBangRound1 = false;
				
				char name[128];
				GetClientName(client, name, sizeof(name));
				
				if (gConVar_FlashBang_RoundStart_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "AdminFlashRoundStart", name);
				
				ServerCommand("sm_hpgrenadesroundshp @all 1");
				ServerCommand("sm_disarmgrenadesroundshp @all");
				ServerCommand("sm_givegrenadesroundshp @all flashbang");
				ServerCommand("sm_givegrenadesroundshp @all knife");
				
				ServerCommand("sm_knifeoffgrenadesrounds");
				
				ServerCommand("sv_infinite_ammo 1");
			}
		}
		if (StrEqual(selectedItem, "8"))
		{
			if (GetUserFlagBits(client))
			{
				FlashBangRound = false;
				FlashBangRound1 = true;
				
				char name[128];
				GetClientName(client, name, sizeof(name));
				
				if (gConVar_FlashBang_RoundForceStop_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "AdminFlashRoundStop", name);
				
				ServerCommand("sm_hpgrenadesroundshp @all 100");
				ServerCommand("sm_disarmgrenadesroundshp @all");
				ServerCommand("sm_givegrenadesroundshp @all knife");
				
				ServerCommand("sm_knifeongrenadesrounds");
				
				ServerCommand("sv_infinite_ammo 0");
				
				if (gConVar_ForceStopRound_ResetCoolDown.BoolValue)
					Cooldown = 0;
			}
		}
		
		//Decoy
		if (StrEqual(selectedItem, "9"))
		{
			if (GetUserFlagBits(client))
			{
				DecoyRound = true;
				DecoyRound1 = false;
				
				char name[128];
				GetClientName(client, name, sizeof(name));
				
				if (gConVar_Decoy_RoundStart_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "AdminDecoyRoundStart", name);
				
				ServerCommand("sm_hpgrenadesroundshp @all 1");
				ServerCommand("sm_disarmgrenadesroundshp @all");
				ServerCommand("sm_givegrenadesroundshp @all decoy");
				ServerCommand("sm_givegrenadesroundshp @all knife");
				
				ServerCommand("sm_knifeoffgrenadesrounds");
				
				ServerCommand("sv_infinite_ammo 1");
			}
		}
		if (StrEqual(selectedItem, "10"))
		{
			if (GetUserFlagBits(client))
			{
				DecoyRound = false;
				DecoyRound1 = true;
				
				char name[128];
				GetClientName(client, name, sizeof(name));
				
				if (gConVar_Decoy_RoundForceStop_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "AdminDecoyRoundStop", name);
				
				ServerCommand("sm_hpgrenadesroundshp @all 100");
				ServerCommand("sm_disarmgrenadesroundshp @all");
				ServerCommand("sm_givegrenadesroundshp @all knife");
				
				ServerCommand("sm_knifeongrenadesrounds");
				
				ServerCommand("sv_infinite_ammo 0");
				
				if (gConVar_ForceStopRound_ResetCoolDown.BoolValue)
					Cooldown = 0;
			}
		}
		
	}
	else if (action == MenuAction_End)
	{
		delete menu;
	}
}

//OnRoundEnd
//OnRoundEnd
//OnRoundEnd

public Action OnRoundEnd(Event event, const char[] name, bool dontBroadcast)
{
	if (MolotovRound)
	{
		if (IsValidClient)
		{
			if (gConVar_Molotov_RoundEnd_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "MolotovRoundEnd");
			
			ServerCommand("sv_infinite_ammo 0");
			
			ServerCommand("sm_hpgrenadesroundshp @all 100");
			ServerCommand("sm_disarmgrenadesroundshp @all");
			ServerCommand("sm_givegrenadesroundshp @all knife");
			
			MolotovRound = false;
			MolotovRound1 = true;
		}
	}
	
	if (HERound)
	{
		if (IsValidClient)
		{
			if (gConVar_HE_RoundEnd_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "HERoundEnd");
			
			ServerCommand("sv_infinite_ammo 0");
			
			ServerCommand("sm_hpgrenadesroundshp @all 100");
			ServerCommand("sm_disarmgrenadesroundshp @all");
			ServerCommand("sm_givegrenadesroundshp @all knife");
			
			HERound = false;
			HERound1 = true;
		}
	}
	
	if (SmokeRound)
	{
		if (IsValidClient)
		{
			if (gConVar_Smoke_RoundEnd_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "SmokeRoundEnd");
			
			ServerCommand("sv_infinite_ammo 0");
			
			ServerCommand("sm_hpgrenadesroundshp @all 100");
			ServerCommand("sm_disarmgrenadesroundshp @all");
			ServerCommand("sm_givegrenadesroundshp @all knife");
			
			SmokeRound = false;
			SmokeRound1 = true;
		}
	}
	
	if (FlashBangRound)
	{
		if (IsValidClient)
		{
			if (gConVar_FlashBang_RoundEnd_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "RoundEnd");
			
			ServerCommand("sv_infinite_ammo 0");
			
			ServerCommand("sm_hpgrenadesroundshp @all 100");
			ServerCommand("sm_disarmgrenadesroundshp @all");
			ServerCommand("sm_givegrenadesroundshp @all knife");
			
			FlashBangRound = false;
			FlashBangRound1 = true;
		}
	}
	
	if (DecoyRound)
	{
		if (IsValidClient)
		{
			if (gConVar_Decoy_RoundEnd_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "DecoyRoundEnd");
			
			ServerCommand("sv_infinite_ammo 0");
			
			ServerCommand("sm_hpgrenadesroundshp @all 100");
			ServerCommand("sm_disarmgrenadesroundshp @all");
			ServerCommand("sm_givegrenadesroundshp @all knife");
			
			DecoyRound = false;
			DecoyRound1 = true;
		}
	}
}

//KNIFE OFF

public void OnClientPutInServer(int client)
{
	SDKHook(client, SDKHook_OnTakeDamage, TakeDamageHook);
}

public Action TakeDamageHook(int client, int &attacker, int &inflictor, float &damage, int &damagetype)
{
	if (!KnifeDamage)
	{
		if ((client >= 1) && (client <= MaxClients) && (attacker >= 1) && (attacker <= MaxClients) && (attacker == inflictor))
		{
			char WeaponName[64];
			GetClientWeapon(attacker, WeaponName, sizeof(WeaponName));
			if (StrContains(WeaponName, "knife", false) != -1)
			{
				damage = 0.0;
				return Plugin_Changed;
			}
		}
	}
	return Plugin_Continue;
}

public Action KnifeOff(int client, int args)
{
	KnifeDamage = false;
}

public Action KnifeOn(int client, int args)
{
	KnifeDamage = true;
}


/*Action OnRoundEnd(Event event, const char[] name, bool dontBroadCast)
{
	for (int client = 1; client <= MaxClients; client++)
	{
		if (IsClientInGame(client) && !IsFakeClient(client) && CheckCommandAccess(client, "admin_commands", ADMFLAG_GENERIC))
		{
			ServerCommand("sm_disarmgrenadesroundshp @all");
			return Plugin_Continue;
		}
	}
	
	//NO ADMINS ONLINE
	ServerCommand("sm_disarmgrenadesroundshp @all");
	return Plugin_Continue;
} */


//ADVADMIN
//ADVADMIN
//ADVADMIN
//ADVADMIN
//ADVADMIN
//ADVADMIN

char WeaponsList[][] = 
{
	"knife", "decoy", "flashbang", "hegrenade", "molotov", "smokegrenade"
};


public Action CMD_Disarm(int client, int args)
{
	if (args != 1)
	{
		ReplyToCommand(client, "%t", "CMD_Disarm_Usage");
		return Plugin_Handled;
	}
	
	/*new String:target_name[MAX_TARGET_LENGTH], 
	String:buffer[64], 
	target_list[MAXPLAYERS], 
	bool:tn_is_ml, 
	target_count;*/
	
	char target_name[MAX_TARGET_LENGTH];
	char buffer[128];
	int target_list[MAXPLAYERS];
	int target_count;
	bool tn_is_ml;
	
	GetCmdArg(1, buffer, sizeof(buffer));
	if ((target_count = ProcessTargetString(buffer, client, target_list, MAXPLAYERS, COMMAND_FILTER_ALIVE, target_name, sizeof(target_name), tn_is_ml)) <= 0)
	{
		ReplyToTargetError(client, target_count);
		return Plugin_Handled;
	}
	
	for (int i = 0; i < target_count; i++)
	{
		DisarmPlayer(target_list[i]);
	}
	return Plugin_Handled;
}

int DisarmPlayer(int client)
{
	for (int i = 0; i < 5; i++)
	{
		int weapon = -1;
		while ((weapon = GetPlayerWeaponSlot(client, i)) != -1)
		{
			if (IsValidEntity(weapon))
			{
				RemovePlayerItem(client, weapon);
			}
		}
	}
	SetEntProp(client, Prop_Send, "m_bHasDefuser", 0);
	SetEntProp(client, Prop_Send, "m_bHasHeavyArmor", 0);
	SetEntProp(client, Prop_Send, "m_ArmorValue", 0);
	SetEntProp(client, Prop_Send, "m_bHasHelmet", 0);
}

public Action CMD_Health(int client, int args)
{
	if (args != 2)
	{
		ReplyToCommand(client, "%t", "CMD_Health_Usage");
		return Plugin_Handled;
	}
	
	char target_name[MAX_TARGET_LENGTH];
	char buffer[128];
	int target_list[MAXPLAYERS];
	int target_count;
	bool tn_is_ml;
	
	GetCmdArg(1, buffer, sizeof(buffer));
	if ((target_count = ProcessTargetString(buffer, client, target_list, MAXPLAYERS, COMMAND_FILTER_ALIVE, target_name, sizeof(target_name), tn_is_ml)) <= 0)
	{
		ReplyToTargetError(client, target_count);
		return Plugin_Handled;
	}
	
	GetCmdArg(2, buffer, sizeof(buffer));
	int value = StringToInt(buffer);
	
	for (int i = 0; i < target_count; i++)
	{
		if ((buffer[0] == '+') || (buffer[0] == '-'))
		{
			value = value + GetEntProp(target_list[i], Prop_Data, "m_iHealth");
		}
		SetEntProp(target_list[i], Prop_Data, "m_iHealth", value);
	}
	return Plugin_Handled;
}

public Action CMD_Give(int client, int args)
{
	if ((args != 1) && (args != 2))
	{
		ReplyToCommand(client, "%t", "CMD_Give_Usage");
		return Plugin_Handled;
	}
	
	char target_name[MAX_TARGET_LENGTH];
	char buffer[128];
	int target_list[MAXPLAYERS];
	int target_count;
	bool tn_is_ml;
	
	GetCmdArg(1, buffer, sizeof(buffer));
	if ((target_count = ProcessTargetString(buffer, client, target_list, MAXPLAYERS, COMMAND_FILTER_ALIVE, target_name, sizeof(target_name), tn_is_ml)) <= 0)
	{
		ReplyToTargetError(client, target_count);
		return Plugin_Handled;
	}
	
	GetCmdArg(2, buffer, sizeof(buffer));
	if (StrEqual(buffer, "", false))
	{
		Format(buffer, sizeof(buffer), "knife");
	}
	
	int type = ItemType(buffer);
	if (!type)
	{
		if (tn_is_ml)
		{
			PrintToChatAll("%t", "CMD_Give", target_name, buffer);
		}
		else
		{
			PrintToChatAll("%t", "CMD_Give", "_s", target_name, buffer);
		}
		ReplyToCommand(client, "%t", "CMD_Invalid_Weapon");
		return Plugin_Handled;
	}
	
	for (int i = 0; i < target_count; i++)
	{
		if (StrEqual(buffer, "knife", false) && !GetConVarBool(FindConVar("mp_drop_knife_enable")))
		{
			int knife = -1;
			while ((knife = GetPlayerWeaponSlot(target_list[i], 2)) != -1)
			{
				if (IsValidEntity(knife))
				{
					RemovePlayerItem(target_list[i], knife);
				}
			}
		}
		GivePlayerWeapon(target_list[i], buffer, type);
	}
	return Plugin_Handled;
}

int GivePlayerWeapon(int client, char[] weapon, int type)
{
	char buffer[64];
	if (type == 1)
	{
		Format(buffer, sizeof(buffer), "weapon_%s", weapon);
	}
	else
	{
		Format(buffer, sizeof(buffer), "item_%s", weapon);
	}
	return GivePlayerItem(client, buffer);
}

int ItemType(char[] itemname)
{
	for (int i = 0; i < sizeof(WeaponsList); i++)
	{
		if (StrEqual(itemname, WeaponsList[i], false))
		{
			return 1;
		}
	}
	return 0;
}

//IsValidClient
//IsValidClient
//IsValidClient

public bool IsValidClient(int client)
{
	return (1 <= client && client <= MaxClients && IsClientInGame(client));
}



///////////////////////////////
//GRENADES ROUBDS FOR PLAYERS//
//GRENADES ROUBDS FOR PLAYERS//
//GRENADES ROUBDS FOR PLAYERS//
//GRENADES ROUBDS FOR PLAYERS//
//GRENADES ROUBDS FOR PLAYERS//
//GRENADES ROUBDS FOR PLAYERS//
///////////////////////////////

//MODE 1 - RONDA DE MOLOTOV
//MODE 2 - RONDA DE HE
//MODE 3 - RONDA DE SMOKE
//MODE 4 - RONDA DE FLASH
//MODE 5 - RONDA DE DECOY

public void OnMapStart()
{
	ModeVoted = false;
	
	yes = 0;
	no = 0;
	
	Cooldown = 2;
}

public Action GrenadesRoundsMenu(int client, int args)
{
	OpenGrenadesRoundsMenu(client);
}

void OpenGrenadesRoundsMenu(int client)
{
	Menu menu = new Menu(mMenu);
	if (Cooldown == 0 && !ShowMenuGrenadesRoundsVotes)
	{
		menu.SetTitle("%t\n ", "GrenadesRoundsMenuTitle");
	}
	else
	{
		menu.SetTitle("%t\n ", "GrenadesRoundsMenuDelayTitle", Cooldown);
	}
	if (Cooldown == 0 && !ShowMenuGrenadesRoundsVotes)
	{
		char MolotovRoundStartMenu1[128];
		char HERoundStartMenu1[128];
		char SmokeRoundStartMenu1[128];
		char FlashRoundStartMenu1[128];
		char DecoyRoundStartMenu1[128];
		
		Format(MolotovRoundStartMenu1, sizeof(MolotovRoundStartMenu1), "%t", "MolotovRoundStartMenu");
		menu.AddItem("11", MolotovRoundStartMenu1);
		
		Format(HERoundStartMenu1, sizeof(HERoundStartMenu1), "%t", "HERoundStartMenu");
		menu.AddItem("22", HERoundStartMenu1);
		
		Format(SmokeRoundStartMenu1, sizeof(SmokeRoundStartMenu1), "%t", "SmokeRoundStartMenu");
		menu.AddItem("33", SmokeRoundStartMenu1);
		
		Format(FlashRoundStartMenu1, sizeof(FlashRoundStartMenu1), "%t", "FlashRoundStartMenu");
		menu.AddItem("44", FlashRoundStartMenu1);
		
		Format(DecoyRoundStartMenu1, sizeof(DecoyRoundStartMenu1), "%t", "DecoyRoundStartMenu");
		menu.AddItem("55", DecoyRoundStartMenu1);
	}
	else
	{
		char MolotovRoundStartMenu1[128];
		char HERoundStartMenu1[128];
		char SmokeRoundStartMenu1[128];
		char FlashRoundStartMenu1[128];
		char DecoyRoundStartMenu1[128];
		
		Format(MolotovRoundStartMenu1, sizeof(MolotovRoundStartMenu1), "%t", "MolotovRoundStartMenu");
		menu.AddItem("11", MolotovRoundStartMenu1, ITEMDRAW_DISABLED);
		
		Format(HERoundStartMenu1, sizeof(HERoundStartMenu1), "%t", "HERoundStartMenu");
		menu.AddItem("22", HERoundStartMenu1, ITEMDRAW_DISABLED);
		
		Format(SmokeRoundStartMenu1, sizeof(SmokeRoundStartMenu1), "%t", "SmokeRoundStartMenu");
		menu.AddItem("33", SmokeRoundStartMenu1, ITEMDRAW_DISABLED);
		
		Format(FlashRoundStartMenu1, sizeof(FlashRoundStartMenu1), "%t", "FlashRoundStartMenu");
		menu.AddItem("44", FlashRoundStartMenu1, ITEMDRAW_DISABLED);
		
		Format(DecoyRoundStartMenu1, sizeof(DecoyRoundStartMenu1), "%t", "DecoyRoundStartMenu");
		menu.AddItem("55", DecoyRoundStartMenu1, ITEMDRAW_DISABLED);
		
	}
	menu.Display(client, MENU_TIME_FOREVER);
}

public int mMenu(Menu menu, MenuAction action, int client, int param2)
{
	switch (action)
	{
		case MenuAction_Select:
		{
			char name[128];
			GetClientName(client, name, sizeof(name));
			
			char szItem[32];
			menu.GetItem(param2, szItem, sizeof(szItem));
			
			
			if (StrEqual(szItem, "11"))
			{
				Mode = -1;
				
				if (gConVar_Start_Vote_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "StartVoteMolotovRound", name);
				
				StartVotingMenu();
			}
			if (StrEqual(szItem, "22"))
			{
				Mode = -2;
				
				if (gConVar_Start_Vote_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "StartVoteHERound", name);
				
				StartVotingMenu();
			}
			if (StrEqual(szItem, "33"))
			{
				Mode = -3;
				
				if (gConVar_Start_Vote_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "StartVoteSmokeRound", name);
				
				StartVotingMenu();
			}
			if (StrEqual(szItem, "44"))
			{
				Mode = -4;
				
				if (gConVar_Start_Vote_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "StartVoteFlashRound", name);
				
				StartVotingMenu();
			}
			if (StrEqual(szItem, "55"))
			{
				Mode = -5;
				
				if (gConVar_Start_Vote_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "StartVoteDecoyRound", name);
				
				StartVotingMenu();
			}
		}
		case MenuAction_End:
		{
			delete menu;
		}
	}
}

void StartVotingMenu()
{
	for (int i = 1; i <= MaxClients; i++)
	{
		if (!IsClientInGame(i))continue;
		Menu menu = new Menu(mVotingMenu);
		
		if (Mode == -1)
		{
			menu.SetTitle("%t", "VoteMolotovRound");
		}
		if (Mode == -2)
		{
			menu.SetTitle("%t", "VoteHERound");
		}
		if (Mode == -3)
		{
			menu.SetTitle("%t", "VoteSmokeRound");
		}
		if (Mode == -4)
		{
			menu.SetTitle("%t", "VoteFlashRound");
		}
		if (Mode == -5)
		{
			menu.SetTitle("%t", "VoteDecoyRound");
		}
		menu.AddItem("yes", "Sim");
		menu.AddItem("no", "Não");
		
		menu.Display(i, 10);
	}
	
	ShowMenuGrenadesRoundsVotes = true;
	
	CreateTimer(15.0, tTimerCountVotes);
}

public int mVotingMenu(Menu menu, MenuAction action, int param1, int param2)
{
	switch (action)
	{
		case MenuAction_Select:
		{
			char szItem[32];
			menu.GetItem(param2, szItem, sizeof(szItem));
			if (StrEqual(szItem, "yes"))
			{
				if (CheckCommandAccess(param1, "", ADMFLAG_CUSTOM1))
				{
					yes++;
				}
				yes++;
			}
			else
			{
				if (CheckCommandAccess(param1, "", ADMFLAG_CUSTOM1))
				{
					no++;
				}
				no++;
			}
		}
	}
}

public Action tTimerCountVotes(Handle timer)
{
	if (yes > no)
	{
		if (Mode == -1 || Mode == -2 || Mode == -3 || Mode == -4 || Mode == -5 || Mode == -6)
		{
			ModeVoted = true;
		}
		
		if (gConVar_Votes_Resultes_Message.BoolValue)
			CPrintToChatAll("%s %t", g_ChatPrefix, "VoteYes");
	}
	else
	{
		if (gConVar_Votes_Resultes_Message.BoolValue)
			CPrintToChatAll("%s %t", g_ChatPrefix, "VoteNo");
		
		Cooldown = gConVar_CoolDown.IntValue;
		
		ModeVoted = false;
		
		ShowMenuGrenadesRoundsVotes = false;
	}
	yes = 0;
	no = 0;
}

public Action OnRoundStart1(Event event, const char[] name, bool dontBroadcast)
{
	if (Cooldown > 0)
	{
		Cooldown--;
	}
	if (ModeVoted)
	{
		Cooldown = gConVar_CoolDown.IntValue;
		
		ModeVoted = false;
		
		ShowMenuGrenadesRoundsVotes = false;
		
		if (Mode == -1)
		{
			MolotovRound = true;
			MolotovRound1 = false;
			
			if (gConVar_Molotov_RoundStart_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "MolotovRoundStart");
			
			ServerCommand("sm_hpgrenadesroundshp @all 150");
			ServerCommand("sm_disarmgrenadesroundshp @all");
			ServerCommand("sm_givegrenadesroundshp @all molotov");
			ServerCommand("sm_givegrenadesroundshp @all knife");
			
			ServerCommand("sm_knifeoffgrenadesrounds");
			
			ServerCommand("sv_infinite_ammo 1");
		}
		if (Mode == -2)
		{
			HERound = true;
			HERound1 = false;
			
			if (gConVar_HE_RoundStart_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "HERoundStart");
			
			ServerCommand("sm_hpgrenadesroundshp @all 150");
			ServerCommand("sm_disarmgrenadesroundshp @all");
			ServerCommand("sm_givegrenadesroundshp @all hegrenade");
			ServerCommand("sm_givegrenadesroundshp @all knife");
			
			ServerCommand("sm_knifeoffgrenadesrounds");
			
			ServerCommand("sv_infinite_ammo 1");
		}
		if (Mode == -3)
		{
			SmokeRound = true;
			SmokeRound1 = false;
			
			if (gConVar_Smoke_RoundStart_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "SmokeRoundStart");
			
			ServerCommand("sm_hpgrenadesroundshp @all 150");
			ServerCommand("sm_disarmgrenadesroundshp @all");
			ServerCommand("sm_givegrenadesroundshp @all smokegrenade");
			ServerCommand("sm_givegrenadesroundshp @all knife");
			
			ServerCommand("sm_knifeoffgrenadesrounds");
			
			ServerCommand("sv_infinite_ammo 1");
		}
		if (Mode == -4)
		{
			FlashBangRound = true;
			FlashBangRound1 = false;
			
			if (gConVar_FlashBang_RoundStart_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "FlashRoundStart");
			
			ServerCommand("sm_hpgrenadesroundshp @all 150");
			ServerCommand("sm_disarmgrenadesroundshp @all");
			ServerCommand("sm_givegrenadesroundshp @all flashbang");
			ServerCommand("sm_givegrenadesroundshp @all knife");
			
			ServerCommand("sm_knifeoffgrenadesrounds");
			
			ServerCommand("sv_infinite_ammo 1");
		}
		if (Mode == -5)
		{
			DecoyRound = true;
			DecoyRound1 = false;
			
			if (gConVar_Decoy_RoundStart_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "DecoyRoundStart");
			
			ServerCommand("sm_hpgrenadesroundshp @all 150");
			ServerCommand("sm_disarmgrenadesroundshp @all");
			ServerCommand("sm_givegrenadesroundshp @all decoy");
			ServerCommand("sm_givegrenadesroundshp @all knife");
			
			ServerCommand("sm_knifeoffgrenadesrounds");
			
			ServerCommand("sv_infinite_ammo 1");
		}
	}
} 